Package org.eclipse.osgi.signedcontent

# Interface SignedContentFactory

public interface SignedContentFactory
A factory used to create `SignedContent` objects.

The framework will register a factory implementation as an OSGi service. This service can be used to get `SignedContent` for a bundle. It can also be used to get `SignedContent` for a repository file. The supported formats for file repositories are jar files and directories containing the content of an extracted jar.

This interface is not intended to be implemented by clients.

Since:
  3.4
Restriction:
  This interface is not intended to be implemented by clients.

## Method Summary

Modifier and Type
Method
Description
`SignedContent`
`getSignedContent(File content)`
Returns a `SignedContent` object for the specified content of a repository.
`SignedContent`
`getSignedContent(Bundle bundle)`
Returns a `SignedContent` object for the specified bundle.

## Method Details

### getSignedContent

SignedContent getSignedContent(File content) throws IOException, InvalidKeyException, SignatureException, CertificateException, NoSuchAlgorithmException, NoSuchProviderException
Returns a `SignedContent` object for the specified content of a repository.

Parameters:
  `content` - the content of the repository
Returns:
  signed content for the specified repository
Throws:
  `IOException` - if an IO exception occurs while reading the repository
  `NoSuchProviderException` - if there's no security provider for the signed content
  `NoSuchAlgorithmException` - if the cryptographic algorithm is not available for the signed content
  `CertificateException` - if there is a problem with one of the certificates of the signed content
  `SignatureException` - if there is a problem with one of the signatures of the signed content
  `InvalidKeyException` - if there is a problem with one of the certificate keys of the signed content

### getSignedContent

SignedContent getSignedContent(Bundle bundle) throws IOException, InvalidKeyException, SignatureException, CertificateException, NoSuchAlgorithmException, NoSuchProviderException
Returns a `SignedContent` object for the specified bundle.

Parameters:
  `bundle` - the bundle to get a signed content for.
Returns:
  signed content for the specified bundle.
Throws:
  `IOException` - if an IO exception occurs while reading the bundle content
  `NoSuchProviderException` - if there's no security provider for the signed content
  `NoSuchAlgorithmException` - if the cryptographic algorithm is not available for the signed content
  `CertificateException` - if there is a problem with one of the certificates of the signed content
  `SignatureException` - if there is a problem with one of the signatures of the signed content
  `InvalidKeyException` - if there is a problem with one of the certificate keys of the signed content